//
//  MemoryIssuesViewController.m
//  Week9_Miscellaneous
//
//  Created by Jason Fieldman on 3/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MemoryIssuesViewController.h"


@implementation MemoryIssuesViewController

- (id) init {
	if (self = [super init]) {
		self.title = @"Memory";
		self.view = [[[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 480)] autorelease];
	
		/* Container for allocations */
		myArray = [[NSMutableArray alloc] init];
		
		/* Initialize and add the buttons */
		but1 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		but1.frame = CGRectMake(50, 50, 100, 50);
		[but1 setTitle:@"Allocation" forState:UIControlStateNormal];
		[but1 addTarget:self action:@selector(handleButton1Press:) forControlEvents:UIControlEventTouchUpInside];
		[self.view addSubview:but1];
		
		but2 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		but2.frame = CGRectMake(170, 50, 100, 50);
		[but2 setTitle:@"Leaks" forState:UIControlStateNormal];
		[but2 addTarget:self action:@selector(handleButton2Press:) forControlEvents:UIControlEventTouchUpInside];
		[self.view addSubview:but2];
		
		/* Localized string */
		helloworld = [[[UILabel alloc] initWithFrame:CGRectMake(0, 150, 320, 30)] autorelease];
		helloworld.textAlignment = UITextAlignmentCenter;
		helloworld.text = NSLocalizedString(@"TAG1", @"Comment");
		[self.view addSubview:helloworld];
	}
	return self;
}


- (void)dealloc {
	/* WHY IS THIS helloworld RELEASE INCORRECT? */
	[helloworld release];
	
	[myArray release];
    [super dealloc];
}


#define kAllocSize 10000

- (void) handleButton1Timer:(NSTimer*)timer {
	NSLog(@"Allocating data");
	char newchars[kAllocSize];
	for (int i = 0; i < kAllocSize; i++) newchars[i] = 'a';
	newchars[kAllocSize-1] = 0;
	NSString *newString = [NSString stringWithCString:newchars];
	[myArray addObject:newString];
}

- (void) handleButton1Press:(id)sender {
	[NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(handleButton1Timer:) userInfo:nil repeats:YES];
}

- (void) handleButton2Press:(id)sender {
	NSString *leaked = [[NSString alloc] initWithFormat:@"Leaked String!!"];
}



@end
