//
//  ThreadingViewController.m
//  Week9_Miscellaneous
//
//  Created by Jason Fieldman on 3/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ThreadingViewController.h"


@implementation ThreadingViewController

- (id) init {
	if (self = [super init]) {
		self.title = @"Threading";
		self.view = [[[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 480)] autorelease];
		
	
		/* Initialize and add the buttons */
		UIButton *but1 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		but1.frame = CGRectMake(50, 50, 100, 50);
		[but1 setTitle:@"Detach" forState:UIControlStateNormal];
		[but1 addTarget:self action:@selector(handleButton1Press:) forControlEvents:UIControlEventTouchUpInside];
		[self.view addSubview:but1];
		
		UIButton *but2 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		but2.frame = CGRectMake(170, 50, 100, 50);
		[but2 setTitle:@"Background" forState:UIControlStateNormal];
		[but2 addTarget:self action:@selector(handleButton2Press:) forControlEvents:UIControlEventTouchUpInside];
		[self.view addSubview:but2];
		
	}
	return self;
}


- (void)dealloc {
    [super dealloc];
}

- (void) backgroundLoop {
	int i = 1;
	[NSThread setThreadPriority:0];
	while (1) {
		NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		NSString *logstr = [NSString stringWithFormat:@"Thread [%d] iteration %d", [NSThread currentThread], i];
		[self performSelectorOnMainThread:@selector(outputToLog:) withObject:logstr waitUntilDone:YES];
		i++;
		[NSThread sleepForTimeInterval:1];
		[pool drain];
	}
}

- (void) handleButton1Press:(id)sender {
	[NSThread detachNewThreadSelector:@selector(backgroundLoop) toTarget:self withObject:nil];
}

- (void) handleButton2Press:(id)sender {
	[self performSelectorInBackground:@selector(backgroundLoop) withObject:nil];
}

- (void) outputToLog:(NSString*)str {
	NSLog(@"%@", str);
}


@end
